// pvm_ex.cc 

#include "pvm.h"
#include <iostream.h>
#include <stdlib.h>


const TAG=1;

void master(PVM& pvm, int ntask)
{
    cout << endl << "Table of Cubes" << endl << endl ;
    int children[ntask];
    pvm.spawn(children, ntask);
    
    cout << "Starting tasks..." <<endl;
    for(int i=0;i<ntask;i++) {
	pvm.init_send();
	pvm.pack_int(i);
	pvm.send_to_task(children[i],TAG);
	cout<<"t"<<children[i]<<" ";
    }
    cout<<endl<<endl;
    
    cout << "machine\t\t task \t\tn\tn^2\tn^3"<<endl
	 << "------------------------------------------------------"<<endl;
    for (int i=0;i<ntask; i++) {
	pvm.wait_next_mesg(TAG); 
	char host[256];
	pvm.unpack_str(host);
	int taskid=pvm.unpack_int();
	int n=pvm.unpack_int();
	int n2=pvm.unpack_int();
	int n3=pvm.unpack_int();
	cout << host << "\t\t t" << taskid
	     << "\t"<< n <<"\t"<< n2 <<"\t"<< n3 <<endl;
    }
}

void child(PVM& pvm) 
{
    pvm.wait_next_mesg(TAG);
    int n=pvm.unpack_int();

    pvm.init_send();
    pvm.pack_str(pvm.hostname());
    pvm.pack_int(pvm.taskid());
    pvm.pack_int(n);
    int n2=n*n;
    pvm.pack_int(n*n);
    int n3=n*n2;
    pvm.pack_int(n3);
    pvm.send_to_parent(TAG);
}

int 
main(int argc, char* argv[])
{
    PVM pvm(argv[0]);

    if (pvm.noparent()) {
	int ntask = (argc==2)?atoi(argv[1]):3;
        master(pvm, ntask);
    } else 
	child(pvm);

    return 0;
}

