/* ----------------------------------------------------------------------
    HECKE: Program for computing with modular forms
    Copyright (C) 1999  William A. Stein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    William A. Stein
    2041 Francisco Street, Apt. 14
    Berkeley, CA  94709
    was@math.berkeley.edu
------------------------------------------------------------------------- */

/*
   FILE:   tables.cc 
   DESC:   creating tables of modular forms data. 
*/

#ifndef TABLES_H
#define TABLES_H

#include "h1nchi.h"
#include "h1nchiz.h"

class Tables {
public:
  Tables (bool i_save=false) : save(i_save) {}

  void anlist_g0new() const;
  void aplist_g1new() const;

  void aplist_g0new_modp() const;

  void heckedisc_Sk() const;
  void heckedisc_Sknew() const;
  void heckedisc_normalization_Sknew() const;
  void heckedisc_T1_Tg() const;

  void bsd() const;

  void supersingular() const ;

  void dimg0() const;
  void dimg0new() const;
  void dimg1() const;
  void dimg1new() const;

  void cpg0() const;
  void cpg0new() const ;
  void cpg1() const;
  void cpg1new() const;


  void exceptional(int N) const;
  void go_non_exceptional() const;
  void non_exceptional(int N) const;


  void heckegens_skg0() const;


  void help() const ;
  void interactive() const ;

private:
  void processing(int N, char* func=NULL) const;
  bool save ;
} ;

#endif // TABLES_H
